// Mousebk.cpp : Defines the initialization routines for the DLL.
//


//  Copyright Luis B. Almeida, 1996, 1998, 2002.
//  
//  This file is part of SendToBack.
//
//  SendToBack is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  SendToBack is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with SendToBack; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


#include "stdafx.h"
#include "Mousebk.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define ALTFLAG 65536*KF_ALTDOWN
#define UPFLAG 0x80000000
#define REPEATFLAG 65536*KF_REPEAT
#define HKSHIFT 256*HOTKEYF_SHIFT
#define HKCONTROL 256*HOTKEYF_CONTROL
#define HKALT 256*HOTKEYF_ALT

#pragma data_seg(".hkdata")
	HHOOK hmhook = NULL;
	HHOOK hkhook = NULL;
	int command = 1;
	BOOL mouseDisabled = FALSE;
	BOOL hotKey1Disabled = FALSE;
	DWORD hotKey1 = 0;
	BOOL hotKey2Disabled = FALSE;
	DWORD hotKey2 = 0;
	BOOL hotKey3Disabled = FALSE;
	DWORD hotKey3 = 0;
	DWORD key;
	BOOL activated = FALSE;
	int count = 0;

#pragma data_seg()



/////////////////////////////////////////////////////////////////////////////
// CMousebkApp

BEGIN_MESSAGE_MAP(CMousebkApp, CWinApp)
	//{{AFX_MSG_MAP(CMousebkApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMousebkApp construction

CMousebkApp::CMousebkApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}


LRESULT CALLBACK KeyboardProc(int nCode, WPARAM wParam, LPARAM lParam)
{
	char *classnamep, classname[50];
	HWND hwnd, hwnd1, hwnd2;
	LONG extStyle;

	 if (nCode < 0)  /* do not process the message */
        return CallNextHookEx(hkhook, nCode, wParam, lParam);

	 key = (DWORD) wParam;

	 if (GetAsyncKeyState(VK_SHIFT) < 0) key = key + HKSHIFT;
	 if (GetAsyncKeyState(VK_CONTROL) < 0) key = key + HKCONTROL;
	 if (lParam & ALTFLAG) key = key + HKALT;

	if (key == hotKey1 && !hotKey1Disabled)
	{

		if (!(lParam & UPFLAG))  // process  only he UP messages of the hotkey, 
			return 1;							//  but don' allow anyone else to process any of the hokey's messages

		classnamep = &classname[1];

		hwnd = GetForegroundWindow();

		GetClassName(hwnd, classnamep, 50);

		extStyle = GetWindowLong(hwnd, GWL_EXSTYLE);

		if ((extStyle & WS_EX_TOPMOST) == 0)	// non-topmost windows go to the back
				SetWindowPos(hwnd, HWND_BOTTOM, 0,0,0,0, SWP_NOACTIVATE+SWP_NOMOVE+SWP_NOSIZE);
		else																		// topmost windows go behind the last topmost window and stay topmost
		{
			hwnd1 = hwnd;
			while (extStyle & WS_EX_TOPMOST)		// find the bottom topmost window; this silly loop is needed because the call
			{																				// GetWindow(hwnd, GW_HWNDLAST) doesn't do what MS says it does
				hwnd2 = hwnd1;
				hwnd1 = GetWindow(hwnd1,GW_HWNDNEXT);		// get next window
				extStyle = GetWindowLong(hwnd1, GWL_EXSTYLE);
			}
			SetWindowPos(hwnd, hwnd2, 0,0,0,0, SWP_NOACTIVATE+SWP_NOMOVE+SWP_NOSIZE);
		}

		return 1;		// never allow others to process the hotkey
	}

	if (key == hotKey2 && !hotKey2Disabled)
	{

			if (!(lParam & UPFLAG))  // process only he UP messages of the hotkey, 
			  return 1;								//  but don' allow anyone else to process any of the hokey's messages

		classnamep = &classname[1];

		hwnd = GetForegroundWindow();

		GetClassName(hwnd, classnamep, 50);

		SetWindowPos(hwnd, HWND_TOP, 0,0,0,0, SWP_NOACTIVATE+SWP_NOMOVE+SWP_NOSIZE);

		return 1;		// never allow others to process the hotkey
	}

	if (key == hotKey3 && !hotKey3Disabled)
	{

			if (!(lParam & UPFLAG))  // process  only he UP messages of the hotkey, 
			  return 1;								//  but don' allow anyone else to process any of the hokey's messages

		classnamep = &classname[1];

		hwnd = GetForegroundWindow();

		GetClassName(hwnd, classnamep, 50);

		if ((GetWindowLong(hwnd, GWL_EXSTYLE) & WS_EX_TOPMOST) == 0)
		{
			SetWindowPos(hwnd, HWND_TOPMOST, 0,0,0,0, SWP_NOACTIVATE+SWP_NOMOVE+SWP_NOSIZE);
			SetWindowPos(hwnd, HWND_TOP, 0,0,0,0, SWP_NOACTIVATE+SWP_NOMOVE+SWP_NOSIZE);
		}
		else
		{
			SetWindowPos(hwnd, HWND_NOTOPMOST, 0,0,0,0, SWP_NOACTIVATE+SWP_NOMOVE+SWP_NOSIZE);
			SetWindowPos(hwnd, HWND_BOTTOM, 0,0,0,0, SWP_NOACTIVATE+SWP_NOMOVE+SWP_NOSIZE);
		}


		return 1;		// never allow others to process the hotkey
	}

	return CallNextHookEx(hkhook, nCode, wParam, lParam);
}



LRESULT CALLBACK MouseProc(int nCode, WPARAM wParam, LPARAM lParam)
{
	LPMOUSEHOOKSTRUCT lpMouseHookStruct;
	char *classnamep, classname[50];
	HWND hwnd, hwnd1, hwnd2;
	LONG extStyle;
	
    if (nCode < 0 || mouseDisabled)  /* do not process the message */
        return CallNextHookEx(hmhook, nCode, wParam, lParam);

	lpMouseHookStruct = (LPMOUSEHOOKSTRUCT)lParam;

	classnamep = &classname[1];

	hwnd = lpMouseHookStruct->hwnd;

//	while(hwnd) hwnd = GetParent(hwnd);

	GetClassName(lpMouseHookStruct->hwnd, classnamep, 50);

	switch(command)
	{

	case 1:

		if (strcmp(classnamep, "Shell_TrayWnd"))
		{
			extStyle = GetWindowLong(hwnd, GWL_EXSTYLE);

			if ((wParam == WM_NCRBUTTONDOWN) &&
				(lpMouseHookStruct->wHitTestCode == HTCAPTION))
			{
				if ((extStyle & WS_EX_TOPMOST) == 0)		// non-topmost window
				{
					SetWindowPos(lpMouseHookStruct->hwnd, HWND_BOTTOM, 0,0,0,0,
						SWP_NOACTIVATE+SWP_NOMOVE+SWP_NOSIZE);
				}
				else																			//topmost window
				{
					hwnd1 = hwnd;
					while (extStyle & WS_EX_TOPMOST)		// find the bottom topmost window; this silly loop is needed because the call
					{																				// GetWindow(hwnd, GW_HWNDLAST) doesn't do what MS says it does
						hwnd2 = hwnd1;
						hwnd1 = GetWindow(hwnd1,GW_HWNDNEXT);		// get next window
						extStyle = GetWindowLong(hwnd1, GWL_EXSTYLE);
					}
					SetWindowPos(hwnd, hwnd2, 0,0,0,0, SWP_NOACTIVATE+SWP_NOMOVE+SWP_NOSIZE);
				}
				activated = TRUE;
				return 1;
			}
		}
   
		if ((wParam == WM_NCRBUTTONUP || wParam == WM_RBUTTONUP) && activated)
		{
			activated = FALSE;
			return 1;
		}

		if (wParam == WM_RBUTTONDOWN) activated = FALSE;

		break;

	case 2:

		extStyle = GetWindowLong(hwnd, GWL_EXSTYLE);
	
		if ((wParam == WM_NCMBUTTONDOWN) &&
			(lpMouseHookStruct->wHitTestCode == HTCAPTION))
		{
			if((extStyle & WS_EX_TOPMOST) == 0)
			{
				SetWindowPos(lpMouseHookStruct->hwnd, HWND_BOTTOM, 0,0,0,0,
					SWP_NOACTIVATE+SWP_NOMOVE+SWP_NOSIZE);
			}
 			else
			{
				hwnd1 = hwnd;
				while (extStyle & WS_EX_TOPMOST)		// find the bottom topmost window; this silly loop is needed because the call
				{																				// GetWindow(hwnd, GW_HWNDLAST) doesn't do what MS says it does
					hwnd2 = hwnd1;
					hwnd1 = GetWindow(hwnd1,GW_HWNDNEXT);		// get next window
					extStyle = GetWindowLong(hwnd1, GWL_EXSTYLE);
				}
				SetWindowPos(hwnd, hwnd2, 0,0,0,0, SWP_NOACTIVATE+SWP_NOMOVE+SWP_NOSIZE);
			}
		activated = TRUE;
		return 1;
		}
  
		if ((wParam == WM_NCMBUTTONUP || wParam == WM_MBUTTONUP) && activated)
		{
			activated = FALSE;
			return 1;
		}

		if (wParam == WM_MBUTTONDOWN) activated = FALSE;

		break;

	}

	return CallNextHookEx(hmhook, nCode, wParam, lParam);
}

_declspec(dllexport) void Sendhhook(HHOOK mh, HHOOK kh)
{
	hmhook = mh;
	hkhook = kh;
}

_declspec(dllexport) void Senddata(int c, BOOL md, BOOL hk1d, DWORD hk1, BOOL hk2d, DWORD hk2, BOOL hk3d, DWORD hk3)
{
	command = c;
	mouseDisabled = md;
	hotKey1Disabled = hk1d;
	hotKey1 = hk1;
	hotKey2Disabled = hk2d;
	hotKey2 = hk2;
	hotKey3Disabled = hk3d;
	hotKey3 = hk3;
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CMousebkApp object

CMousebkApp theApp;
