// Sendbk.cpp : Defines the class behaviors for the application.
//


//  Copyright Luis B. Almeida, 1996, 1998, 2002.
//  
//  This file is part of SendToBack.
//
//  SendToBack is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  SendToBack is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with SendToBack; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


#include "stdafx.h"
#include "Sendbk.h"
#include "SendbkDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

LRESULT CALLBACK MouseProc(int, WPARAM, LPARAM);
LRESULT CALLBACK KeyboardProc(int, WPARAM, LPARAM);

_declspec(dllimport) void Sendhhook(HHOOK, HHOOK);

HINSTANCE dllhandle;
HOOKPROC ProcAddr;

int nType;
HOOKPROC hkprc;
HHOOK hmhook;
HHOOK hkhook;
HWND hdialog;


/////////////////////////////////////////////////////////////////////////////
// CSendbkApp

BEGIN_MESSAGE_MAP(CSendbkApp, CWinApp)
	//{{AFX_MSG_MAP(CSendbkApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSendbkApp construction

CSendbkApp::CSendbkApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CSendbkApp object

CSendbkApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CSendbkApp initialization

BOOL CSendbkApp::InitInstance()
{
	// CG: This line was added by the OLE Control Containment component
	AfxEnableControlContainer();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	hdialog = FindWindow(NULL, "SendToBack options");
	if (hdialog !=NULL)
	{
		ShowWindow(hdialog, SW_RESTORE);
	}
	else
	{
	
		dllhandle = LoadLibrary("Mousebk.dll");
		ProcAddr = (HOOKPROC) GetProcAddress(dllhandle,"MouseProc");
		nType = WH_MOUSE;
		hmhook = SetWindowsHookEx(nType, ProcAddr, dllhandle, 0);
		ProcAddr = (HOOKPROC) GetProcAddress(dllhandle,"KeyboardProc");
		nType = WH_KEYBOARD;
		hkhook = SetWindowsHookEx(nType, ProcAddr, dllhandle, 0);
		Sendhhook(hmhook, hkhook);

		CSendbkDlg dlg;
		m_pMainWnd = &dlg;
		int nResponse = dlg.DoModal();
		if (nResponse == IDOK)
		{
			// TODO: Place code here to handle when the dialog is
			//  dismissed with OK
		}
		else if (nResponse == IDCANCEL)
		{
			// TODO: Place code here to handle when the dialog is
			//  dismissed with Cancel
		}

		UnhookWindowsHookEx(hmhook);
		UnhookWindowsHookEx(hkhook);
		FreeLibrary(dllhandle);
	}

	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.

	return FALSE;
}

